Draft PathArray/tr: Difference between revisions

From FreeCAD Documentation
(Updating to match new version of source page)
(Updating to match new version of source page)
Line 1: Line 1:
<languages/>
<languages/>
{{Docnav
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}
|[[Draft_LinkArray|Link Array]]
|[[Draft_PathLinkArray|Path LinkArray]]
|[[Draft_Module|Draft]]
|IconL=Draft_LinkArray.svg
|IconR=Draft_PathLinkArray.svg
|IconC=Workbench_Draft.svg
}}


<div class="mw-translate-fuzzy">
<div class="mw-translate-fuzzy">
Line 8: Line 15:
==Description==
==Description==


The {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft PathArray|Draft PathArray]]}} tool places copies of a selected shape along a selected path, which can be a [[Draft Wire|Draft Wire]], a [[Draft BSpline|Draft BSpline]], and similar edges.
The {{Button|[[Image:Draft_PathArray.svg|16px]] [[Draft_PathArray|Draft PathArray]]}} tool places copies of a selected shape along a selected path, which can be a [[Draft_Wire|Draft Wire]], a [[Draft_BSpline|Draft BSpline]], and similar edges.


The PathArray tool can be used on any object that has a [[Part_TopoShape|Part TopoShape]], meaning 2D shapes created with the [[Draft_Workbench|Draft Workbench]], but also 3D solids created with other workbenches, for example, [[Part_Workbench|Part]], [[PartDesign_Workbench|PartDesign]], or [[Arch_Workbench|Arch]].
The PathArray tool can be used on any object that has a [[Part_TopoShape|Part TopoShape]], meaning 2D shapes created with the [[Draft_Workbench|Draft Workbench]], but also 3D solids created with other workbenches, for example, [[Part_Workbench|Part]], [[PartDesign_Workbench|PartDesign]], or [[Arch_Workbench|Arch]].
Line 174: Line 181:




{{Docnav
{{Docnav|[[Draft_LinkArray|Link Array]]|[[Draft_PathLinkArray|Path LinkArray]]|[[Draft_Module|Draft]]|IconL=Draft_LinkArray.svg|IconC=Workbench_Draft.svg|IconR=Draft_PathLinkArray.svg}}
|[[Draft_LinkArray|Link Array]]
|[[Draft_PathLinkArray|Path LinkArray]]
|[[Draft_Module|Draft]]
|IconL=Draft_LinkArray.svg
|IconR=Draft_PathLinkArray.svg
|IconC=Workbench_Draft.svg
}}


{{Draft Tools navi{{#translation:}}}}
{{Draft Tools navi{{#translation:}}}}

Revision as of 14:19, 1 December 2020

Yol dizisi

Menü konumu
Draft → PathArray
Tezgahlar
Draft, Arch
Varsayılan kısayol
Hiçbiri
Versiyonda tanıtıldı
-
Ayrıca bkz
Draft Array

Description

The Draft PathArray tool places copies of a selected shape along a selected path, which can be a Draft Wire, a Draft BSpline, and similar edges.

The PathArray tool can be used on any object that has a Part TopoShape, meaning 2D shapes created with the Draft Workbench, but also 3D solids created with other workbenches, for example, Part, PartDesign, or Arch.

Object arranged along a path

Usage

  1. Select the object that you wish to distribute.
  2. Select the path object or edges along which the object will be distributed.
  3. Press the PathArray button.
  4. The Array object is immediately created. You must change the properties of the array to change the number and direction of copies created.

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

Note: if the VeriBase object doesn't seem to be positioned correctly in the path, check that its VeriPlacement is in the origin (0,0,0). Certain objects can be placed anywhere in the 3D space when used with the PathArray tool, but others must be at the origin, particularly those created by using Part Extrude with a 2D profile like a Sketch.

Options

There are no options for this tool. Either it works with the selected objects or not.

Properties

A PathArray is derived from a Part Feature (Part::Feature class), therefore it shares all the latter's properties. In addition to the properties described in Part Feature, the PathArray has the following properties in the property editor.

Alignment

  • VeriAlign (Bool): if it is true the copies will be aligned to the path; otherwise they are left in their default orientation.
Note: in certain cases the shape will appear flat, in reality it may have moved in the 3D space, so instead of using a flat view, change the view to axonometric.
  • VeriAlign Mode (Enumeration): three modes, Original, Frenet, Tangent.
  • VeriExtra Translation (VectorDistance): additional displacement vector (x, y, z) that will be applied to each copy along the path. This is useful to make small adjustments in the position of the copies, for example, when its reference point doesn't match the center point of its shape.
  • VeriForce Vertical (Bool): if it is true, the value of VeriVertical Vector will be used as the local Z direction, when VeriAlign Mode is Original or Tangent. introduced in version 0.19
  • VeriTangent Vector (Vector): it defaults to (1, 0, 0); alignment unit vector that will be used when VeriAlign Mode is Tangent. introduced in version 0.19
  • VeriVertical Vector (Vector): it defaults to (0, 0, 1); unit vector of the local Z direction that will be used when VeriVertical Vector is true. introduced in version 0.19

Objects

  • VeriBase (LinkGlobal): specifies the object to duplicate in the path.
  • VeriCount (Integer): specifies the number of copies to create in the path.
  • VeriPath Object (LinkGlobal): specifies the object along which the copies will be distributed. It must contain 'Edges' in its Part TopoShape; for example, it could be a Wire or BSpline.
  • VeriPath Subelements (LinkSubListGlobal): specifies the sub-elements (edges) of the VeriPath Object on which the copies will be created. The copies will be created only on these edges. If this property is empty, the copies will be distributed on the entire VeriPath Object.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The PathArray tool can be used in macros and from the Python console by using the following function:

Older call

path_array = makePathArray(base_object, path_object, count, xlate=None, align=False, pathobjsubs=[])

New call

path_array = make_path_array(base_object, path_object,
                             count=4, extra=App.Vector(0, 0, 0), subelements=None,
                             align=False, align_mode="Original", tan_vector=App.Vector(1, 0, 0),
                             force_vertical=False, vertical_vector=App.Vector(0, 0, 1),
                             use_link=True):
  • Creates a "PathArray" object from the base_object, by placing as many as count copies along path_object.
    • Instead of a reference to an object, base_object and path_object can also be Labels (strings) of objects existing in the current document.
    • If extra is given, it is a vector that displaces each of the individual copies by a small amount.
    • If subelements is given, it is a list of edges of path_object, for example, ['Edge1', 'Edge2']; the copies will be created along this shorter path.
    • If align is True, the copies are aligned along the path_object depending on the value of align_mode, which may be "Original", "Frenet" or "Tangent".
    • If tan_vector is given, it is a unit vector that defines the local tangent direction of the copy along the path. It is used when align_mode is "Tangent".
    • If force_vertical is True, the value of vertical_vector is used to determine the local Z direction of the copy along the path. It is used when align_mode is "Original" or "Tangent".
    • If use_link is True, the type of array created will be a PathLinkArray, whose elements are App Link instances instead of simple copies.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

p1 = App.Vector(500, -1000, 0)
p2 = App.Vector(1500, 1000, 0)
p3 = App.Vector(3000, 500, 0)
p4 = App.Vector(4500, 100, 0)
spline = Draft.make_bspline([p1, p2, p3, p4])
obj = Draft.make_polygon(3, 500)

path_array = Draft.make_path_array(obj, spline, 6)
doc.recompute()

wire = Draft.make_wire([p1, -p2, -p3, -p4])
path_array2 = Draft.make_path_array(obj, wire, count=3, extra=App.Vector(0, -500, 0), subelements=["Edge2", "Edge3"], align=True, force_vertical=True)
doc.recompute()

Technical explanation for the Align property

When VeriAlign is false, the placement of the copied shapes is easy to understand; they are just moved to a different position in their original orientation.

Align false
Align false

Object arranged along a closed path in the original orientation

When VeriAlign is true, the positioning of the shapes becomes a bit more complex:

  1. First, Frenet coordinate systems are built on the path: X is tangent, Z is normal, Y is binormal.
  2. Then the original object is copied to every on-path coordinate system, so that the global origin is matched with the on-path coordinate system origin.

Object arranged along a closed path; description of components and path

The following images show how the array is produced, depending on which plane the path is.

Path on XY Plane:

Object arranged along a closed path which is aligned to the XY plane

Path on XZ Plane:

Object arranged along a closed path which is aligned to the XZ plane

Path on YZ Plane:

Object arranged along a closed path which is aligned to the YZ plane

As you reorient the path but not the object, the result is consistent: the object remains aligned to the path the way it was before reorienting the path.

Editor: thank you to user DeepSOIC for this explanation.

Additional alignment modes and options introduced in v0.19

Original mode (the default) is the historic alignment mode as in version 0.18. It is not really the Frenet alignment. Original mode uses the normal parameter from Draft.getNormal (or the default) as a constant - it does not calculate curve normal. X follows the curve tangent, Y is the normal parameter, Z is X.Cross(Y).

Tangent mode is similar to Original, but includes a rotation to align the Base object's X to the TangentVector before placing copies. After the rotation, Tangent behaves the same as Original. In previous versions this rotation would be performed manually before invoking PathArray.

Frenet mode orients the copies to a coordinate system along the path. X is tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not be computed (ex a straight line), the default is used.

The ForceVertical option applies to Original and Tangent modes. When this option is applied, the normal parameter from Draft.getNormal is ignored. X follows the curve tangent, Z is the VerticalVector property and Y is X.Cross(Z).

Version 18 cycle chain - Original mode

Align false
Align false

Railway cross ties (sleepers) - Tangent mode + ForceVertical

Align false
Align false

Frenet Mode

Align false
Align false